#!/usr/bin/env python3

import objc, zipfile, re
from AppKit import *

PICEXT = '\.(jpe?g|png|gif)$'

class ComipoliArchive:
    def __init__(self):
        self.status = 0
        self.namelist = []
        self.path = ''
        #self.height = 1

    def new_archive(self, path):#, is_unrar, is_7za):
        self.path = path
        if re.search(r'\.(cbz|zip)$', self.path, re.I):
            self.status = 0
            self.namelist.clear()
            with zipfile.ZipFile(self.path) as o:
                l = o.namelist()
                l.sort()
                for name in l:
                    if re.search(PICEXT, name, re.I):
                        self.namelist.append(name)
                        #print(name)
            '''elif is_unrar and re.search(r'\.(cbr|rar)$', self.path, re.I):
                self.status = 1
                self.namelist.clear()
                result, output, error, status = GLib.spawn_command_line_sync('unrar vt -p- -- "{0}"'.format(self.path))
                lines = output.decode("utf-8").split("\n")
                for line in lines:
                    s = line.lstrip()
                    if s.startswith('Name: '):
                        name = s[6:]
                        if GLib.Regex.match_simple("\.(jpe?g|png|gif)$", name, GLib.RegexCompileFlags.CASELESS, 0):
                            self.namelist.append(name)
            elif is_7za and re.search(r'\.(cb7|7z)$', self.path, re.I):
                self.status = 2
                self.namelist.clear()
                result, output, error, status = GLib.spawn_command_line_sync('7za l -slt "{0}"'.format(self.path))
                lines = output.decode("utf-8").split("\n")
                for line in lines:
                    if line.startswith('Path'):
                        name = line[7:]
                        if GLib.Regex.match_simple("\.(jpe?g|png|gif)$", name, GLib.RegexCompileFlags.CASELESS, 0):
                            self.namelist.append(name)
            '''
        else:
            return False
        return True

    def __getitem__(self, num):
        #stream = None
        if (self.status == 0):
            with zipfile.ZipFile(self.path) as o:
                b = o.read(self.namelist[num])
                data = NSData.dataWithBytes_length_(b, len(b))
                return NSImage.alloc().initWithData_(data)
        '''
        elif (self.status == 1):
            sp = Gio.Subprocess.new(["unrar", "p", "-inul", "-@", "--", self.path, self.namelist[num]], Gio.SubprocessFlags.STDOUT_PIPE)
            stream = sp.get_stdout_pipe()
        elif (self.status == 2):
            sp = Gio.Subprocess.new(["7za", "x", "-so", self.path, self.namelist[num]], Gio.SubprocessFlags.STDOUT_PIPE)
            stream = sp.get_stdout_pipe()
        try:
            p = GdkPixbuf.Pixbuf.new_from_stream(stream)
            ph = p.get_width()
            pw = p.get_height()
            p = p.scale_simple(self.height * ph / pw, self.height, GdkPixbuf.InterpType.BILINEAR)
        except Exception as e:
            print(self.namelist[num])
            print(e)
        stream.close()
        return p
        '''

    def __len__(self):
        return len(self.namelist)
